<?php

elgg_register_event_handler('init', 'system', 'uocKpax_init');

function uocKpax_init() {
    $base = elgg_get_plugins_path() . 'uocKpax';
	
	//elgg_register_library('uoc', "$base/vendors/uocoauth/src/uoc.php");
	
	elgg_register_library('uoc', "$base/lib/uoc_api.php");
	elgg_register_library('uocKpax', "$base/lib/uocKpax.php");

	elgg_load_library('uoc');
	elgg_load_library('uocKpax');

	elgg_extend_view('css/elgg', 'uocKpax/css');
	

	// View sign on with UOC         
	
	if (uocKpax_allow_sign_on_with_uoc()) {
	     error_log('oscar uocKpax_allow_sign_on_with_uoc');
		 elgg_extend_view('login/extend', 'uocKpax/login');
	}
	error_log('oscar uocKpax_api_init');

	// register page handler
	// si es fa una crida a una pagina del tipus /uocKpax_api/* executara la funcio uocKpax_api_pagehandler
	elgg_register_page_handler('uocKpax', 'uocKpax_pagehandler');


    // register Walled Garden public pages. Aixo es el que permet accedir a recurs sense haver fet login
	elgg_register_plugin_hook_handler('public_pages', 'walled_garden', 'uocKpax_public_pages');		
    
	error_log('oscar uocKpax_init2');	
	
}

/**
 * al fer una crida a una url del tipus /uocKpax_api/* s'executara aquesta funcio
 * si fem per exemple una crida a  /uocKpax_api/login , llavors $page[0] conté el string 'login'
 *
 */
function uocKpax_pagehandler($page) {
    
	error_log('oscar uocKpax_pagehandler');
	
	global $CONFIG;
	

	if (!isset($page[0])) {  //si no hi ha definits parametres no fem res
		forward();
	}
	$_GET['session'] = $CONFIG->input['session'];

	//test
	if ($page[0] == 'add') {
      include elgg_get_plugins_path() . 'uocKpax/pages/uocKpax/add.php';
      return true;
    }
	//end test
	
	
	if ($page[0] == 'login') {
		error_log('oscar uocKpax_pagehandler -> uocKpax_login');
		uocKpax_login();
	} else {
		error_log('oscar uocKpax_pagehandler -> forward');
		forward();
	}
	
}

/**
 * Register as public pages for walled garden.
 *
 * @param string $hook
 * @param string $type
 * @param array  $return_value
 * @param array  $params
 * @return array
 */
function uocKpax_public_pages($hook, $type, $return_value, $params) {
	
	error_log('oscar uocKpax_public_pages');
	
	$return_value[] = 'uocKpax/forward';
	$return_value[] = 'uocKpax/login';

	return $return_value;
}




